/*                          =======================
============================   C/C++ HEADER FILE   ============================
                            =======================                       *//**
  BoardInfo.h

  Created by Onno Dirkzwager on 22.11.2018.
  Copyright (c) 2018 IOTAppStory. All rights reserved.

*///===========================================================================
#ifdef ESP8266
#ifndef __BoardInfo_h__
#define __BoardInfo_h__

/*---------------------------------------------------------------------------*/
/*                                    INCLUDES                               */
/*---------------------------------------------------------------------------*/

extern "C" {
#include "user_interface.h"          // used by the RTC memory read/write functions
}

/*---------------------------------------------------------------------------*/
/*                            DEFINITIONS AND MACROS                         */
/*---------------------------------------------------------------------------*/

#define MAGICBYTE 85
#define RTCMEMBEGIN 68

/*---------------------------------------------------------------------------*/
/*                        TYPEDEFS, CLASSES AND STRUCTURES                   */
/*---------------------------------------------------------------------------*/

/*                          =======================
============================   STRUCT DEFINITION   =============================
                            =======================                        *//**
  rtcMemDef.

*//*=========================================================================*/
typedef struct {
    uint8_t markerFlag;
    int bootTimes;
    char boardMode = 'N';                // Normal operation or Configuration mode?
} RtcMemDef __attribute__((aligned(4)));

/*                          =======================
============================   CLASS DEFINITION    ============================
                            =======================                       *//**
  BoardInfo.

*//*=========================================================================*/
class BoardInfo {
public:
    BoardInfo(int &bootTimes, char &boardMode);
    void read();
    void write();

private:
    int* _bootTimes;
    char* _boardMode;
};

/*---------------------------------------------------------------------------*/
/*                                GLOBAL VARIABLES                           */
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/*                                    EOF                                    */
/*---------------------------------------------------------------------------*/
#endif // __BoardInfo_h__
#endif // ESP8266